// OuvertureXml.pde
// 
// Gerard Paresys Guy Kayser
// 29 10 2015
// Processing 2.2.1
//

// String[] list;
XML xml1, kid1, kid2;
XML[] kid1Data, kidkid1Data, kidkid1intervals, kidkid1intervalsxmax;
String DebutNomFichier     = "";
String NomFichierPitch     = "XXX_Pitch.txt";
String NomFichierIntensity = "XXX_Intensity.txt";
String NomFichierAudio     = "XXX" + ExtensionFichierAudio;
String NomFichierCarte     = "XXX.png";
float DureeFichier;

void SelectionFichier(File FichierChoisi) {
  if (FichierChoisi == null) {
    println("1 Pas de fichier XXX.xml ouvert!");
    exit();
  } else {
    Ouverture(FichierChoisi.getAbsolutePath(), 0);
    // Nom = split(FichierChoisi.getName(), '.')[0];
  }
}


void Ouverture(String NomFichier, int Voix) {
  boolean Probleme = false;

  File Fichier = new File(dataPath(NomFichier));
  if (!Fichier.exists()) { 
    println("2 Le fichier " + NomFichier + " n'existe pas");
    Probleme = true;
  } else ;// println("Selection:    " + NomFichier);

  if (!Probleme) {
    // list = split(NomFichier, '.');
    // NomFichierXML = list[0] + ".xml";
    // DebutNomFichier = join(shorten(list), ".");
    DebutNomFichier = join(shorten(split(NomFichier, '.')), "."); // A cause des path avec plusieurs .
    NomFichierXML = DebutNomFichier + ".xml";

    if (loadStrings(NomFichierXML) == null) { 
      println("3 Le fichier " + NomFichierXML + " n'existe pas");
      Probleme = true;
    }
  }

  if (!Probleme) {
    xml1 = loadXML(NomFichierXML);  //Processing 2.0
    // println("Ouverture de: " + NomFichierXML);
    println(NomFichierXML);
    if (Verbose) println("1-----------------------------------------------------------");
    // NombreDeChild1 = xml1.getChildCount();
    if (xml1.hasChildren()) { 
      //  println("xml1.hasChildren");
      if (Verbose) println("xml1.listChildren() : ");
      if (Verbose) println(xml1.listChildren());
    } else {
      println("4 Le fichier xml n'a pas le bon format");      
      Probleme = true;
    }
  }

  if (!Probleme) {
    if (!(xml1.listChildren()[1] == "items" )) {
      println("5 Le fichier xml n'a pas le bon format");
      Probleme = true;
    }
  }

  if (!Probleme) {
    kid1Data = xml1.getChildren("items");
    //    println("2-----------------------------------------------------------");
    //    println(kid1Data);
    kidkid1Data = kid1Data[0].getChildren("item");
    //      s2 = kidkid1Data[1].getName();
    //      println("s2 = " + s2);
    if (Verbose) println("kidkid1Data-----------------------------------------------------------");
    // if (Verbose) println(kidkid1Data);  // gros a lister
    if (Verbose) println("-----------------------------------------------------------");
    if (Verbose) println("Length of kidkid1Data = " + kidkid1Data.length);
    if (Verbose) println("kidkid1Data[0].getName() = " + kidkid1Data[0].getName());
    if (Verbose) println("kidkid1Data[1].getName() = " + kidkid1Data[1].getName());
    if (Verbose) println("kidkid1Data[0].listAttributes() = " + kidkid1Data[1].getChildren("item"));

    //    kidkid1intervals = kidkid1Data[4].getChildren("intervals");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println(kidkid1intervals);
    //    println("-----------------------------------------------------------");
    //    println("Length of kidkid1intervals = " + kidkid1intervals.length);
    //    println("kidkid1intervals[10].getName() = " + kidkid1intervals[10].getName());
    //    println("kidkid1intervals[11].getName() = " + kidkid1intervals[11].getName());
    //    println("kidkid1intervals.listAttributes() = " + kidkid1intervals[10].getChildren("intervals"));
    //
    //    // kidkid1intervalsxmax = kidkid1intervals[76].getChildren("xmax");
    //    println();
    //    println("-----------------------------------------------------------");
    //    println("kidkid1intervals[26].getInt(\"n\")      = " + kidkid1intervals[26].getInt("n"));
    //    println("kidkid1intervals[26].getFloat(\"xmax\") = " + kidkid1intervals[26].getFloat("xmax"));
    //    println("kidkid1intervals[26].getFloat(\"xmin\") = " + kidkid1intervals[26].getFloat("xmin"));
    //    println("kidkid1intervals[26].getContent()     = " + kidkid1intervals[26].getContent());
    //    println();
    //    println("kidkid1intervals[27].getFloat(\"xmax\") = " + kidkid1intervals[27].getFloat("xmax"));
    //    println("-----------------------------------------------------------");
    //      println("Length of kidkid1intervalsxmax = " + kidkid1intervalsxmax.length);
    //      println("kidkid1intervalsxmax[10].getName() = " + kidkid1intervalsxmax[10].getName());
    //      println("kidkid1intervalsxmax[11].getName() = " + kidkid1intervalsxmax[11].getName());
    //      println("kidkid1intervalsxmax.listAttributes() = " + kidkid1intervalsxmax[10].getChildren("intervals"));
    //    fill(0);
    //    textFont(maFonte, 16);
    //    fill(180);
    //    textFont(maFonte, 12);
    //    text(NomFichierXML, 10, 65);

    XMLTranscription[Voix] = kidkid1Data[0].getChildren("intervals");
    NbrTranscription[Voix] = XMLTranscription[Voix].length;
    if (Verbose) println();
    if (Verbose) println("XMLTranscriptionnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn");
    if (Verbose) println(XMLTranscription);  // gros a lister
    for (int z = 0; z < XMLTranscription[Voix].length; z++) print(XMLTranscription[Voix][z].getContent() + " ");
    println();
    println("Nbr Transcription = " + NbrTranscription[Voix]); 

    XMLPhoneme[Voix] = kidkid1Data[1].getChildren("intervals");
    NbrPhoneme[Voix] = XMLPhoneme[Voix].length;
    if (Verbose) println();
    if (Verbose) println("XMLPhonemennnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn");
    if (Verbose) println(XMLPhoneme);  // gros a lister
    println("Nbr Phoneme = " + NbrPhoneme[Voix]); 

    XMLMot[Voix] = kidkid1Data[2].getChildren("intervals");
    NbrMot[Voix] = XMLMot[Voix].length;
    //    if (true) println();
    //    if (true) println("XMLMotnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn");
    //    if (true) println(XMLMot[0]);  // gros a lister
    println("Nbr Mot = " + NbrMot[Voix]); 

    XMLSyllabe[Voix] = kidkid1Data[3].getChildren("intervals");
    NbrSyllabe[Voix] = XMLSyllabe[Voix].length; 
    // println("NbrSyllabe[Voix] = " + NbrSyllabe[Voix]);   
    if (Verbose) println();
    if (Verbose) println("XMLSyllabennnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnnn");
    if (Verbose) println(XMLSyllabe);  // gros a lister
    println("Nbr Syllabe = " + NbrSyllabe[Voix]); 
    // println();
  } 

  if (! Probleme) { 
    // NomFichierAudio = list[0] + ExtensionFichierAudio;
    NomFichierAudio = DebutNomFichier + ExtensionFichierAudio;
    if (loadStrings(NomFichierAudio) == null) { 
      println("9 Le fichier " + NomFichierAudio + " n'existe pas");
      Probleme = true;
    } // else println("Ouverture de: " + NomFichierAudio);
  }

  if (! Probleme) { 
    // println(); 
    FinOuverture();
  } else exit();
}

